dtmc

global sync_sends_as_bob: bool init false;

module Alice
alice_has_message: bool init false;

[sn1bobmessage] sn1bob_relays_message = true -> 1.0:(alice_has_message' = true);

endmodule

module Bob
start_state: bool init true;
bob_sent_message_to_sn1: bool init false;
bob_sent_message_to_sn2: bool init false;

[] start_state = true -> 1.0:(bob_sent_message_to_sn1' = true) & (start_state' = false);
[] sync_sends_as_bob = true -> 1.0: (bob_sent_message_to_sn2' = true) & (sync_sends_as_bob' = false);

[bobmessagetosn1] bob_sent_message_to_sn1 = true -> 1.0:(bob_sent_message_to_sn1' = false);
[bobmessagetosn2] bob_sent_message_to_sn2 = true -> 1.0:(bob_sent_message_to_sn2' = false);

endmodule

module Charlie
charlie_has_message: bool init false;

[sn2bobmessage] sn2bob_relays_message = true -> 1.0:(charlie_has_message' = true);

endmodule

module SYNC
sync_has_message: bool init false;

[sn1bobmessage] sn1bob_relays_message = true & sync_has_message = false -> 1.0:(sync_has_message' = true);

[] sync_has_message = true -> 1.0: (sync_has_message' = false) & (sync_sends_as_bob' = true);

endmodule

module SN1Bob
sn1bob_relays_message: bool init false;

[bobmessagetosn1] bob_sent_message_to_sn1 = true -> 1.0:(sn1bob_relays_message' = true);
[sn1bobmessage] sn1bob_relays_message = true -> (sn1bob_relays_message' = false);

endmodule

module SN2Bob
sn2bob_relays_message: bool init false;

[bobmessagetosn2] bob_sent_message_to_sn2 = true -> 1.0:(sn2bob_relays_message' = true);
[sn2bobmessage] sn2bob_relays_message = true -> (sn2bob_relays_message' = false);

endmodule




